/*
Validating processor of an XML Regular Schema Language (Ver 0.60)
Copyright (C) 1999      MURATA Makoto (FAMILY Given)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

MURATA Makoto can be reached at makoto@mars.netspace.or.jp.
If this address does not work, use murata.makoto@fujixerox.co.jp.

Contributor(s): 	

*/

//////////////////////////////////////////////////////////////////////
//
// Datatype.h: Interface of the class Datatype
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DATATYPE_H__10FCF7CC_57FE_11D3_9D6F_B07561C10000__INCLUDED_)
#define AFX_DATATYPE_H__10FCF7CC_57FE_11D3_9D6F_B07561C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef bool (*datatype_validator)(const XMLCh* const);

class Schema;


class Datatype  
{
	friend class InstanceHandler;
	friend class NonTerm;
public:
	static void initialize(Schema&);
	Datatype(const DOMString& nm, int ind, datatype_validator fp);
	~Datatype() {delete ntd_p;}
	NonTerm getNonTerm();
	const XMLCh* key()
	{return ntd_p->name.rawBuffer();}
private:
	NonTermDescriptor* ntd_p; //owned by this object
	datatype_validator fun_p;
	Datatype();
};


#endif // !defined(AFX_DATATYPE_H__10FCF7CC_57FE_11D3_9D6F_B07561C10000__INCLUDED_)
