/*
Validating processor of an XML Regular Schema Language (Ver 0.60)
Copyright (C) 1999      MURATA Makoto (FAMILY Given)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

MURATA Makoto can be reached at makoto@mars.netspace.or.jp.
If this address does not work, use murata.makoto@fujixerox.co.jp.

Contributor(s): 	

*/

//////////////////////////////////////////////////////////////////////
//
// InstanceHandler.h: Interface of the class InstanceHandler
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INSTANCEHANDLER_H__10FCF7C8_57FE_11D3_9D6F_B07561C10000__INCLUDED_)
#define AFX_INSTANCEHANDLER_H__10FCF7C8_57FE_11D3_9D6F_B07561C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class InstanceHandler : public HandlerBase  
{
public:
	InstanceHandler();
	InstanceHandler(Schema* s_p, bool debug) 
		: schema_p(s_p),stack_index(0),validity(true), locator_p(0),
		debug_option(debug)
	{}
	~InstanceHandler() {}
private:
	Schema*	schema_p;
	FmStates** stack [MASINSTDEPTH];
	int stack_index;
	bool validity;
	bool debug_option;
	FmStates** current_fm_states;

	Locator * locator_p;

	inline FmStates** pop() {return stack[--stack_index];}
	inline FmStates** top() {return stack[stack_index - 1];}
	inline void  push(FmStates** ptr) {stack[stack_index++] = ptr;}

public:
	bool isValid() {return validity;}
	void setDocumentLocator(Locator* const locator);
private:
	void concatenatedCharacter();
	DOMString currentText;
	void startElement(const XMLCh* const name, AttributeList& attributes);
	void endElement(const XMLCh* const name);
	void characters(const XMLCh* const chars, const unsigned int length);
	void updateFmStates(const set<NonTerm>&);
	void startDocument();
	void endDocument();
};

#endif // !defined(AFX_INSTANCEHANDLER_H__10FCF7C8_57FE_11D3_9D6F_B07561C10000__INCLUDED_)
