/*
Validating processor of an XML Regular Schema Language (Ver 0.60)
Copyright (C) 1999      MURATA Makoto (FAMILY Given)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

MURATA Makoto can be reached at makoto@mars.netspace.or.jp.
If this address does not work, use murata.makoto@fujixerox.co.jp.

Contributor(s): 	

*/

//////////////////////////////////////////////////////////////////////
//
// NonTerm.cpp: Implementation of the class NonTerm
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

//////////////////////////////////////////////////////////////////////
// constructors/destructors
//////////////////////////////////////////////////////////////////////

NonTerm::NonTerm(RefHashTableOf<NonTermDescriptor>& nonTermHashtable, 
				 const DOMString& nm)
{
	
	NonTermDescriptor* p = nonTermHashtable.get(nm.rawBuffer());

	if (p != 0) 
		ntd_p = p;
	else {
		RefHashTableOfEnumerator<NonTermDescriptor> 
			ntd_enum(&nonTermHashtable);
		for (int i = 0; ntd_enum.hasMoreElements(); i++) 
			ntd_enum.nextElement();
		ntd_p = new NonTermDescriptor(i + 1, nm);
		nonTermHashtable.put(ntd_p);
	}

}

NonTerm::NonTerm(RefHashTableOf<Datatype>& datatypeHashtable,
				 const DOMString& nm)
{
	
	Datatype* dt_p = datatypeHashtable.get(nm.rawBuffer());

	if (dt_p != 0) 
		ntd_p = dt_p -> ntd_p;
	else {
		XMLCh* msg = new XMLCh [MSGLENGTH];
		msg[0] = 0;
		XMLString::catString(msg, XMLString::transcode("undefined datatype: "));
		XMLString::catString(msg, nm.rawBuffer());
		throw msg;
	}
}


//////////////////////////////////////////////////////////////////////
// The whitespace datatype
//////////////////////////////////////////////////////////////////////

NonTerm NonTerm::whitespace;

//////////////////////////////////////////////////////////////////////
// stream output
//////////////////////////////////////////////////////////////////////
ostream&
operator<<(ostream& os, const NonTerm& n) 
{
	os << *(n.ntd_p);
	return os;
}

TextOutputStream&
operator<<(TextOutputStream& tos, const NonTerm& n) 
{
	tos << *(n.ntd_p);
	return tos;
}

