/*
Validating processor of an XML Regular Schema Language (Ver 0.60)
Copyright (C) 1999      MURATA Makoto (FAMILY Given)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

MURATA Makoto can be reached at makoto@mars.netspace.or.jp.
If this address does not work, use murata.makoto@fujixerox.co.jp.

Contributor(s): 	

*/

//////////////////////////////////////////////////////////////////////
//
// NonTerm.h: Interface of the class NonTerm
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NONTERM_H__10FCF7CB_57FE_11D3_9D6F_B07561C10000__INCLUDED_)
#define AFX_NONTERM_H__10FCF7CB_57FE_11D3_9D6F_B07561C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

ostream&
operator<<(ostream& os, const NonTerm& n); 		// stream output

TextOutputStream&
operator<<(TextOutputStream& tos, const NonTerm& n);// stream output

class NonTerm  
{
	friend ostream& operator<<(ostream& os, const NonTerm& n);
	friend TextOutputStream&
		operator<<(TextOutputStream& tos, const NonTerm& n);
	friend class Datatype;
public:
	NonTerm() {}
	NonTerm(RefHashTableOf<NonTermDescriptor>& nonTermHashtable, 
		const DOMString& nm);
	NonTerm(RefHashTableOf<Datatype>& datatypeHashtable,
		const DOMString& nm);
	NonTerm(const NonTerm& n)
		: ntd_p(n.ntd_p)
	{}
	~NonTerm() {}

	static NonTerm whitespace;
	
	NonTerm& operator=(const NonTerm& n)
	{ntd_p = n.ntd_p;
	return *this; }
	int	operator==(const NonTerm& b) const
	{return (ntd_p->index) == (b.ntd_p->index) ? 1 : 0;}
	int	operator!=(const NonTerm& b) const
	{return *this == b ? 0 : 1;}
	int operator<(const NonTerm& b) const
	{return (ntd_p->index) < (b.ntd_p->index) ? 1 : 0;}
	int	operator>(const NonTerm& b) const
	{return (ntd_p->index) > (b.ntd_p->index) ? 1 : 0;}

private:
	NonTerm(NonTermDescriptor* p) {ntd_p = p;}

private:
	NonTermDescriptor* ntd_p; //not owned by this object.
};


#endif // !defined(AFX_NONTERM_H__10FCF7CB_57FE_11D3_9D6F_B07561C10000__INCLUDED_)
