/*
Validating processor of an XML Regular Schema Language (Ver 0.60)
Copyright (C) 1999      MURATA Makoto (FAMILY Given)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

MURATA Makoto can be reached at makoto@mars.netspace.or.jp.
If this address does not work, use murata.makoto@fujixerox.co.jp.

Contributor(s): 	

*/

//////////////////////////////////////////////////////////////////////
//
// NonTermDescriptor.h: Interface of the class NonTermDescriptor
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NONTERMDESCRIPTOR_H__D9AD5DC0_5936_11D3_9D6F_D07561C10000__INCLUDED_)
#define AFX_NONTERMDESCRIPTOR_H__D9AD5DC0_5936_11D3_9D6F_D07561C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class NonTermDescriptor 
{
	friend ostream& 
		operator<<(ostream& tos, const NonTermDescriptor& nd);
	friend TextOutputStream& 
		operator<<(TextOutputStream& tos, const NonTermDescriptor& nd);
	friend class NonTerm;
	friend class Datatype;
public:
	const XMLCh* key()
	{return name.rawBuffer();} 
	bool is_element() const;
	bool is_datatype() const;
	NonTermDescriptor::NonTermDescriptor(int i, const DOMString& nm);
	~NonTermDescriptor() {}

private:
	NonTermDescriptor();

private:
	DOMString name;
	int index;
};

ostream& operator<<(ostream&, const NonTermDescriptor&);
TextOutputStream& operator<<(TextOutputStream&, const NonTermDescriptor&);

#endif // !defined(AFX_NONTERMDESCRIPTOR_H__D9AD5DC0_5936_11D3_9D6F_D07561C10000__INCLUDED_)
