/*
Validating processor of an XML Regular Schema Language (Ver 0.60)
Copyright (C) 1999      MURATA Makoto (FAMILY Given)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

MURATA Makoto can be reached at makoto@mars.netspace.or.jp.
If this address does not work, use murata.makoto@fujixerox.co.jp.

Contributor(s): 	

*/

//////////////////////////////////////////////////////////////////////
//
// Schema.h: Interface of the class Schema
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCHEMA_H__10FCF7C9_57FE_11D3_9D6F_B07561C10000__INCLUDED_)
#define AFX_SCHEMA_H__10FCF7C9_57FE_11D3_9D6F_B07561C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class RulesPerTagType;


class Schema  
{
	friend class Datatype;
	friend class InstanceHandler;
	friend TextOutputStream& operator<<(TextOutputStream& tos,  Schema& s);
public:
	Schema(const DOM_Document&, bool debug_option);
	~Schema();
	void cm2fm(const DOM_Element&, fm<NonTerm> &);
	void initialize();

private:
	//intentionally undefined constructor
	Schema(); 

	//initialize
	void tagTypeLessRuleInitialize();
	void ruleInitialize();
	void topLevelInitialize();

	//automaton creation
	void minMax(const DOM_Element& dom_elem, fm<NonTerm>& f);
	void cm2fmDatatypeRef(const DOM_Element& dom_elem, fm<NonTerm>& f);
	void cm2fmNonTermRef(const DOM_Element& dom_elem, fm<NonTerm>& f);
	void cm2fmEmpty(const DOM_Element& dom_elem, fm<NonTerm>& f);
	void cm2fmMixed(const DOM_Element& dom_elem, fm<NonTerm>& f);
	void cm2fmSequence(const DOM_Element& dom_elem, fm<NonTerm>& f);
	void cm2fmChoice(const DOM_Element& dom_elem, fm<NonTerm>& f);
	bool cm2fmChoice_easy(const DOM_NodeList& dnl, fm<NonTerm>& f);
	void cm2fmNone(const DOM_Element& dom_elem, fm<NonTerm>& f);
	void cm2fmAnyElement(const DOM_Element& dom_elem, fm<NonTerm>& f);

	//instance variables
	const DOM_Document dom_schema;
	bool debug_option;
	fm<NonTerm> top_fm;
	RefHashTableOf<RulesPerTagType> ruleHashtable;
//	RefHashTableOf<TagType>		tagTypeHashtable;
	RefHashTableOf<NonTermDescriptor> nonTermHashtable;
	RefHashTableOf<TagTypeLessNonTerm>	tagTypeLessNonTermHashtable;
	RefHashTableOf<Datatype>	datatypeHashtable;

	//constants for minOccur and maxOccur
	DOMString D_null;
	DOMString D_zero;
	DOMString D_one;
	DOMString D_infinity;

};

TextOutputStream&
operator<<(TextOutputStream& os,  Schema& s); 		// stream output

#endif // !defined(AFX_SCHEMA_H__10FCF7C9_57FE_11D3_9D6F_B07561C10000__INCLUDED_)
