/*

  This file merely includes Grail source files.

*/


#include "stdafx.h"

#include      "grail30/classes/bits/include.h"
#include      "grail30/classes/state/include.h"
#include      "grail30/classes/array/include.h"
#include      "grail30/classes/set/include.h"
#include      "grail30/classes/pool/include.h"
//#include      "grail30/classes/list/include.h"
#include      "grail30/classes/string/include.h"
#include      "grail30/classes/pair/include.h"
#include      "grail30/classes/inst/include.h"
//#include      "grail30/classes/re/include.h"
#include      "grail30/classes/fm/include.h"
//#include      "grail30/classes/fl/include.h"


template fm<NonTerm>;

char	string<char>::separator = '\0';

void dmy_grail()
{
	set<state> states;
	set<NonTerm> nonTerms;
	fm<NonTerm> nfm;
	cout << states;
	cout << nonTerms;
	cout << nfm;
	outStrm << states;
	outStrm << nonTerms;
	outStrm << nfm;
}

//The functions defined below are adaptations of the original Grail
//program to the class TextOutputStream.

template <class Label>
TextOutputStream&
operator<<(TextOutputStream& tos, const fm<Label>& a)
{
	int		i;
	inst<Label>	t;
	set<state>	ss;

	// output start pseudo-instructions

	a.starts(ss);
	for (i=0; i<ss.size(); ++i)
	{
		t.make_start(ss[i]);

		tos << t << EndLn;

	}

	// output normal instructions

	for (i=0; i<a.size(); ++i)
		tos << a[i]  << EndLn;

	// output final pseudo-instructions

	a.finals(ss);
	for (i=0; i<ss.size(); ++i)
	{
		t.make_final(ss[i]);
		tos << t  << EndLn;
	}

	return tos;
}

template <class Label>
TextOutputStream&
operator<<(TextOutputStream& tos, inst<Label>& t)
{
	// if START instruction

	if (t.is_start())
	{
		tos << START_STATE << inst<Label>::left_delimiter 
			<< START_SYMBOL << inst<Label>::right_delimiter;
		return tos << t.get_sink();
	}

	// if not

	tos << t.get_source() << inst<Label>::left_delimiter;

	// if FINAL instruction;

	if (t.is_final())
		return tos << FINAL_SYMBOL << inst<Label>::right_delimiter 
				<< FINAL_STATE;

	// if not

	return tos << t.get_label() << inst<Label>::right_delimiter 
		<< t.get_sink(); 
}


inline
TextOutputStream&
operator<<(TextOutputStream& tos, const state& s)
{
	return tos << (unsigned int) s.value();
}


template <class Item>
TextOutputStream&
operator<<(TextOutputStream& tos, const set<Item>& s)
{
	for (int i=0; i<s.size(); ++i)
		tos << s[i] << " ";
	return tos << EndLn;
}


